service system/mountfs {
	need = system/initial system/mountroot
	use = system/sraid system/hdparm
	# system/modules
start {
	export PATH="/bin:/sbin:/usr/bin:/usr/sbin"
	retval=0

	#Check all filesystems
	if [ -f /fastboot ]; then
	    rm -f /fastboot
	else
	    if [ -f /forcefsck ] ; then
		echo "A full fsck has been forced"
		/sbin/fsck -C -R -A -a -f
		retval=$?
		rm -f /forcefsck
	    else
		/sbin/fsck -C -T -R -A -a
		retval=$?
	    fi
			
	    if [ ${retval} -eq 0 ] ; then
		echo "All filesystems passed fsck, now mounting .."
	    elif [ ${retval} -eq 8 ] ; then
		echo "Filesystem already mounted, skipping fsck."
	    elif [ ${retval} -ge 1 ] && [ ${retval} -le 3 ] ; then
		echo "Filesystem errors corrected by fsck."
		# Everything should be ok, so return a pass
	    else
		echo "Fsck could not correct all errors, manual repair needed"
		ngc -j sulogin
		exit 1
	    fi
	fi


	# Mount local filesystems in /etc/fstab.
	mount -aFt reiserfs,reiser4,ext2,ext3,xfs,jfs,vfat,ntfs,tmpfs,bind
	if [ ${?} -ne 0 ]; then
	    echo "Mounting failed, trying mount local filesystems again ..."
	    if ! mount -at reiserfs,reiser4,ext2,ext3,xfs,jfs,vfat,ntfs,tmpfs,bind; then
		echo "WARNING, failed to mount some local filesystems"
		#this is not critical, lets continue anyway.
	    fi
	fi

	# Mount all type bind.
	mount -at bind	
	
	# Always return happily.
	exit 0
}

}
